/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package bin;

import chemaxon.formats.MolImporter;
import chemaxon.struc.Molecule;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import makeFP.makeFP;
import processAndSplit.processMolecule;

/**
 *
 * @author mahendra
 */
public class writeFPOnly {

    public static void main(String args[]) throws IOException {

////////////////////////////////////////////////////////////////////////////////////////////////////////
        //(if No Arguments) Print help massage
        if (args.length == 0 || args[0].contains("help")) {

            System.out.println("\n===============================SHAPE FINGERPRINT=================================\n");
            System.out.println("USAGE: -i smile(sdf)File -pH true/false -o outputFile.shFP");
            System.out.println("=================================================================================\n");
            System.out.println("Explnation of Arguments:");
            System.out.println("========================\n");

            System.out.println("-i:         File containing molecules (smi or sdf format)\n");
            System.out.println("-pH:        true=use pH setting, false=do not use pH setting\n");
            System.out.println("-o:         Name of output file\n");

            System.out.println("NOTE:");
            System.out.println("=================================================================================");
            System.out.println("THIS CLASS IS FOR WRITING FINGEPRINT ONLY. IF YOU WOULD LIKE TO DO VIRTUAL\n"
                    + "SCREENING ONLY, PLEASE RUN THE CLASS bin.main!!");
            System.out.println("====================================END=========================================\n");
            System.exit(0);
        }
////////////////////////////////////////////////////////////////////////////////////////////////////////        
        //Set the arguments
        String inFile = null;
        String outFile = null;
        String pHSetting = null;
        boolean usePh = false;

        for (int a = 0; a < args.length; a++) {

            if (args[a].equals("-i")) {

                if (a == (args.length - 1)) {
                    break;
                }
                inFile = args[a + 1];
                break;
            }
        }

        for (int a = 0; a < args.length; a++) {
            if (args[a].equals("-o")) {

                if (a == (args.length - 1)) {
                    break;
                }
                outFile = args[a + 1];
                break;
            }
        }

        for (int a = 0; a < args.length; a++) {

            if (args[a].equals("-pH")) {
                if (a == (args.length - 1)) {
                    break;
                }
                pHSetting = args[a + 1];
                break;
            }
        }
//////////////////////////////////////////////////////////////////////////////////////////////////////
        //check for the all the arguments
        if (inFile == null || outFile == null || pHSetting == null
                || (!pHSetting.contains("true") && !pHSetting.contains("false"))) {

            System.out.println("****************************************************************");
            System.out.println("ERROR: Check for arguments!");
            System.out.println("EXITING for Now!");
            System.out.println("****************************************************************");
            System.exit(0);
        } else {

            System.out.println("\nYOUR INPUT:\n****************************************************************");
            System.out.println("-i " + inFile + " -pH " + pHSetting + " -o " + outFile + "\n");
        }
//////////////////////////////////////////////////////////////////////////////////////////////////////        
        //Check if the file exists or Not
        File file = new File(inFile);
        if (!file.exists()) {
            System.out.println("ERROR: Input file does not exists!");
            System.out.println("EXITING for Now!");
            System.out.println("****************************************************************");
            System.exit(0);
        }
/////////////////////////////////////////////////////////////////////////////////////////////////////
        if (pHSetting.equals("true")) {
            usePh = true;
        }
/////////////////////////////////////////////////////////////////////////////////////////////////////
        //START MAKING FINGERPRINT AND WRITING IT OUT
        BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
        MolImporter miDB = null;
        Molecule dbMol = null;
        boolean control = true;
        double successProcessMolecule = 0;

        try {
            miDB = new MolImporter(inFile);
        } catch (IOException ex) {
            System.out.println("ERROR: while reading input file");
            System.out.println("EXITING for Now!");
            System.out.println("****************************************************************");
            System.exit(0);
        }

        while (control) {

            try {
                dbMol = miDB.read();
            } catch (IOException ex) {
                continue;
            }

            if (dbMol == null) {
                control = false;
                continue;
            }

            //Process database Molecules
            processMolecule processDBmol = new processMolecule(dbMol);
            String processSuccess = null;
            try {
                if (usePh) {
                    processSuccess = processDBmol.process(7.4);
                } else {
                    processSuccess = processDBmol.process();
                }

            } catch (Exception ex) {
                continue;
            }

            if (processSuccess == null) {
                continue;
            }

            //Now time to make a fingerprint
            makeFP dbShapeFP = new makeFP(processDBmol.mol);
            String isOK;
            try {
                isOK = dbShapeFP.createFP(20);
            } catch (Exception ex) {
                continue;
            }
            if (isOK == null) {
                continue;
            }

            //Write it Down
            String smi = dbMol.toFormat("smiles:q0-H");
            String name = dbMol.getName();
            String fp = dbShapeFP.arrayToString(dbShapeFP.shapeFPInt, ";");
            bw.write(smi + " " + name.replace(" ", "_") + " " + fp);
            bw.newLine();

            successProcessMolecule++;
            if (successProcessMolecule % 10000 == 0.0) {
                System.out.println("TOTAL MOLECULES PROCESS SO FAR " + (int) successProcessMolecule);
            }
        }

        bw.close();
        miDB.close();
        System.out.println();
        System.out.println("TOTAL " + (int) successProcessMolecule + " MOLECULES EXPORTED TO " + outFile);
        System.out.println("END");
        System.out.println("****************************************************************");
    }
//////////////////////////////////////////////////////////////////////////////////////////////////////
}